<template>
  <section alertmanager>

    <md-dialog alertmanager-modal md-active v-if="inputQueue[0]">
      <md-dialog-content>
        <p>{{inputQueue[0].message}}</p>
        <md-field>
          <md-textarea md-autogrow ref="textarea"
                       v-model="inputQueue[0].default"
                       :maxlength="inputQueue[0].maxlength"></md-textarea>
        </md-field>
      </md-dialog-content>
      <md-dialog-actions>
        <md-button class="md-primary" v-if="inputQueue[0].cancelable" @click="inputQueue[0].cb()">cancel</md-button>
        <md-button class="md-primary" @click="inputQueue[0].cb(inputQueue[0].default)">submit</md-button>
      </md-dialog-actions>
    </md-dialog>

    <md-dialog alertmanager-modal md-active v-if="getCurrentModal">
      <md-dialog-title v-if="getCurrentModal.title">{{getCurrentModal.title}}</md-dialog-title>
      <md-dialog-content>
        <p>{{getCurrentModal.message}}</p>
      </md-dialog-content>
      <md-dialog-actions>
        <md-button v-for="action in getCurrentModal.actions" :key="action" class="md-primary" @click="getCurrentModal.cb(action)">{{action}}</md-button>
      </md-dialog-actions>
    </md-dialog>
    <section snackbar>
      <transition-group name="alert">
        <div alert v-for="snacc in getSnaccs"
                   :key="snacc.message"
                   :type="snacc.type"
                   :many-actions="snacc.actions.length > 2">
          <p><span v-if="snacc.count > 1">({{snacc.count}}x):&nbsp;</span>{{snacc.message}}</p>
          <div actions>
            <md-button button v-for="action in snacc.actions" :key="action" class="md-dense md-primary" @click="snacc.cb(action)">{{action}}</md-button>
          </div>
        </div>
      </transition-group>
    </section>
  </section>
</template>

<script lang="ts">
import { Component, Vue } from 'vue-property-decorator';
import { store } from '../../store';
import { mount } from '@vue/test-utils';
import { MdDialog } from 'vue-material/dist/components';
import { Alert, AlertOptions, Input, InputOptions, mountMe } from './alerting';

Vue.use(MdDialog);
@Component({
  components: {
  },
})
export default class extends Vue {

  private alertQueue: Alert[] = [];
  private inputQueue: Input[] = [];

  private val = '';

  public askInput(options: InputOptions) {
    return new Promise(ok => {
      const cb = value => {
        this.inputQueue = [];
        ok(value);
      };
      const input: Input = Object.assign({cb}, options);
      this.inputQueue.push(input);
      this.$nextTick(() => {
        const textarea = this.$refs.textarea as Vue;
        if (textarea) {
          const el = textarea.$el as HTMLElement;
          el.focus();
        }
      });
    });
  }

  public showAlert(options: AlertOptions) {
    return new Promise<string>((ok, nok) => {
      const cb = actionName => {
        const index = this.alertQueue.indexOf(alert);
        this.alertQueue.splice(index, 1);
        ok(actionName);
      };
      const alert: Alert = Object.assign({
        count: 1,
        blocking: false,
        timeout: 0,
        actions: ['ok'],
        cb,
      }, options);
      if (alert.timeout) {
        setTimeout(() => alert.cb(''), alert.timeout);
      }
      alert.message = alert.message.trim();
      const duplicate = this.alertQueue.find(a => a.message === alert.message && a.type === alert.type);
      if (duplicate) {
        duplicate.count++;
      } else {
        this.alertQueue.push(alert);
      }
    });
  }

  private created() {
    mountMe(this);
  }

  get store() {
    return store;
  }

  get getCurrentModal() {
    return this.alertQueue.find(a => a.blocking);
  }

  get getSnaccs() {
    return this.alertQueue.filter(a => !a.blocking).slice(0, 5);
  }
}
</script>

<style scoped lang="scss">
@import "~vue-material/src/components/MdLayout/mixins";

[alertmanager] {
  position: fixed;
  bottom: 0;
  left: 0;
  right: 0;
  z-index: 10;

  [snackbar] {
    display: flex;
    flex-direction: column;
    align-items: flex-end;

    [alert] {
      @include md-layout-small-and-up {
        min-width: 600px;
      }
      @include md-layout-xsmall {
        width: 100%;
      }

      &.alert-enter-active, &.alert-leave-active {
        transition: all .3s ease-in-out;
      }
      &.alert-enter, &.alert-leave-to {
        transform: translateX(10px);
        opacity: 0;
      }

      color: white;
      background: md-get-palette-color(bluegrey, 700);
      &[type="warning"] {
        background: md-get-palette-color(yellow, 800);
      }
      &[type="error"] {
        background: md-get-palette-color(red, 700);
      }
      &[type="success"] {
        background: md-get-palette-color(green, 700);
      }

      > p {
        white-space: pre-wrap;
      }

      margin: 5px;
      margin-top: 0;
      padding: 10px;
      border-radius: 4px;

      display: flex;
      flex-direction: row;
      justify-content: space-between;

      &[many-actions] {
        flex-direction: column;
      }
      @include md-layout-xsmall {
        flex-direction: column;
      }

      [actions] {
        display: flex;
        flex-direction: row;
        justify-content: flex-end;
        align-items: flex-end;

        [button] {
          color: md-get-palette-color(gray, 200);
        }
      }
    }
  }
}


</style>